package tools.descartes.prisma.agent.wildfly.callstack;

import java.util.Collection;
import java.util.Collections;

import org.jboss.wsf.spi.invocation.Invocation;

public abstract class ComponentRecord {

	private final TraceFactory factory;
	private final String component;
	private String componentClass = null;
	private final InvocationGroupRecord caller;
	
	public ComponentRecord(TraceFactory factory, String component) {
		this(null, factory, component);
	}
	
	public ComponentRecord(InvocationGroupRecord caller, TraceFactory factory, String component) {
		this.caller = caller;
		this.component = component;
		this.factory = factory;
	}
	
	public void setComponentClass(String componentClass) {
		this.componentClass = componentClass;
	}
	
	public String getComponentClass() {
		return componentClass;
	}
	
	public InvocationGroupRecord getCaller() {
		return caller;
	}
	
	public String getComponentName() {
		return component;
	}
	
	public Collection<InterfaceRecord> getInterfaces() {
		return Collections.emptyList();
	}
	
	public TraceFactory getTraceFactory() {
		return factory;
	}
	
	public abstract InterfaceRecord requireInterface(String interf);
	
	public abstract boolean isFiltered();

	public abstract void accept(TraceVisitor visitor, InvocationGroupRecord source);	

}
